# [OK] 为验证通过
# [WARNING] 为风险提示

import re
import subprocess
import os
import sys

arg_lang = ""
################################
# 常量

# for get_env_lang()
STR_GET_ENV_LANG_ZH     = "语言环境为中文"
STR_GET_ENV_LANG_EN     = "语言环境为英文"
STR_GET_ENV_LANG_UNKNOW = "语言环境未知"

# for is_root()
STR_IS_ROOT_TRUE  = "当前用户为root权限"
STR_IS_ROOT_FALSE = "当前用户没有root权限"

################################
# 环境检查函数

def get_env_lang():
#    lang = os.getenv("LANG")
#    if lang.startswith("zh"):
#        return STR_GET_ENV_LANG_ZH
#    elif lang.startswith("en"):
#        return STR_GET_ENV_LANG_EN
#    else:
#        return STR_GET_ENV_LANG_UNKNOW
#
    if arg_lang == "zh":
        return STR_GET_ENV_LANG_ZH
    elif arg_lang == "en":
        return STR_GET_ENV_LANG_EN
    else:
        return STR_GET_ENV_LANG_UNKNOW

def is_root():
    if os.geteuid() == 0:
        print(STR_IS_ROOT_TRUE)
        return True
    else:
        print(STR_IS_ROOT_FALSE)
        return False

def is_root():
    if os.geteuid() == 0:
        print(STR_IS_ROOT_TRUE)
        return True
    else:
        print(STR_IS_ROOT_FALSE)
        return False

################################
# 辅助函数
def l_print(zh_str, en_str) :
    if STR_GET_ENV_LANG_ZH == get_env_lang() :
        print(zh_str);
    else :
        print(en_str);

################################
# 功能函数

# 确保SSH登录连接超时小于等于60秒
def check_ssh_login_timeout():
    try:
        output = subprocess.check_output("grep 'LoginGraceTime' /etc/ssh/sshd_config", shell=True)
        output = output.decode('utf-8').strip()
        pattern = r'^LoginGraceTime\s+(.*)$'
        match = re.search(pattern, output)
        if match:
            if "60s" in match.group(1):
                l_print("[OK] SSH登录连接超时 检查通过",
                        "[OK] SSH login timeout check passed")
            else:
                l_print(f"[WARNING] SSH登录连接超时 设置为 {match.group(1)}",
                        f"[WARNING] SSH login timeout set to {match.group(1)}")
        else:
            l_print("[OK] SSH登录连接超时未配置 检查通过",
                    "[OK] SSH login timeout not configured check passed")
    except:
        l_print("[OK] SSH服务未安装 检测通过",
                    "[OK] SSH service not installed, check passed")

# 示例代码主函数
def main():

    check_ssh_login_timeout()

if __name__ == '__main__':
    arg_lang = sys.argv[1]

    main()
